from rest_framework.exceptions import ErrorDetail


def parse_serializer_error(
    details,
    parameter=None,
    initial_data=None,
    details_mapping=None,
):
    """
    Create a uniform error object following a standard defined.

    The standard format is:
    "code": 'failed_auth',
    "message": 'Authentication to LabGuru has failed',
    "details": [
        {'parameter': 'title', 'code': 'required', 'message': 'This field is required.'}
    ].

    Args:
    ----
        details: A JSON object that contains errors generated by the serializer.
        parameter: The name of the field that caused the error (optional).
        initial_data: The original data used for validation (optional).
        details_mapping: Custom messages for error codes (optional).

    Returns:
    -------
        A list of uniform error objects, each containing a `parameter`, `code`,
        and `message` following the specified standard.

    Raises:
    ------
        ValueError: If `details` is not a dict, list, `ErrorDetail`, or string.

    """
    if isinstance(details, dict):
        standard_details = []
        for key, value in details.items():
            new_parameter = key
            if parameter:
                new_parameter = parameter + "/" + key
            standard_details += parse_serializer_error(
                details=value,
                parameter=new_parameter,
                initial_data=initial_data[new_parameter]
                if initial_data and new_parameter in initial_data
                else None,
                details_mapping=details_mapping if details_mapping else None,
            )
        return standard_details

    if isinstance(details, list):
        standard_details = []
        for value in details:
            standard_details += parse_serializer_error(
                details=value,
                parameter=parameter,
                initial_data=initial_data,
                details_mapping=details_mapping,
            )
        return standard_details

    if isinstance(details, ErrorDetail):
        return_data = {
            "message": details.__str__(),
        }
        if parameter:
            return_data["parameter"] = parameter

        if details.code:
            detail_code = details.code
            if "not a valid UUID" in details.__str__():
                detail_code = "invalid_uuid"
            return_data["code"] = detail_code
            if initial_data and details_mapping:
                details_message = details_mapping.get(detail_code, "")
                details_message = details_message.format(parameter_value=initial_data)
                return_data["message"] = details_message
            else:
                return_data["message"] = details.__str__()
            if detail_code == "invalid_uuid":
                return_data["code"] = "invalid"
        return [return_data]

    if isinstance(details, str):
        return_data = {
            "message": details,
        }
        if parameter:
            return_data["parameter"] = parameter
        return [return_data]
    raise ValueError("details must be a dict, list, ErrorDetail or str")
